"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseController = exports.Response = void 0;
var errors_1 = require("../errors");
;
var Response = /** @class */ (function () {
    function Response() {
    }
    return Response;
}());
exports.Response = Response;
;
var BaseController = /** @class */ (function () {
    function BaseController() {
    }
    ;
    BaseController.prototype.ok = function (response, data) {
        try {
            if (!data)
                return response.sendStatus(200);
            response.type('application/json');
            return response.status(200).send({ data: data });
        }
        catch (error) {
            throw error;
        }
    };
    ;
    BaseController.prototype.created = function (response) {
        return response.sendStatus(201);
    };
    ;
    BaseController.prototype.clientError = function (message) {
        if (message === void 0) { message = "Bad Request"; }
        throw new errors_1.GenericValidationError({ error: new Error(message), errorCode: 400 });
    };
    ;
    BaseController.prototype.unauthorized = function (message) {
        if (message === void 0) { message = "Unauthorized"; }
        throw new errors_1.GenericValidationError({ error: new Error(message), errorCode: 401 });
    };
    ;
    BaseController.prototype.paymentRequired = function (message) {
        if (message === void 0) { message = "Payment required"; }
        throw new errors_1.GenericValidationError({ error: new Error(message), errorCode: 402 });
    };
    ;
    BaseController.prototype.forbidden = function (message) {
        if (message === void 0) { message = "Forbidden"; }
        throw new errors_1.GenericValidationError({ error: new Error(message), errorCode: 403 });
    };
    ;
    BaseController.prototype.notFound = function (message) {
        if (message === void 0) { message = "Not found"; }
        throw new errors_1.GenericValidationError({ error: new Error(message), errorCode: 404 });
    };
    ;
    BaseController.prototype.conflict = function (message) {
        if (message === void 0) { message = "Conflict"; }
        throw new errors_1.GenericValidationError({ error: new Error(message), errorCode: 409 });
    };
    ;
    BaseController.prototype.tooMany = function (message) {
        if (message === void 0) { message = "Too many requests"; }
        throw new errors_1.GenericValidationError({ error: new Error(message), errorCode: 429 });
    };
    ;
    return BaseController;
}());
exports.BaseController = BaseController;
;
