import { S3 } from 'aws-sdk';
export declare abstract class StorageConnect {
    constructor();
    abstract get storage(): S3;
    abstract get baseFilePath(): string;
    abstract set bucketName(bucketName: string);
    abstract set regionName(regionName: string);
    abstract set accessKeyId(accessKeyId: string);
    abstract set secretAccessKey(secretAccessKey: string);
    abstract set protocol(protocol: string);
    abstract set hostname(hostname: string);
    abstract set apiVersion(apiVersion: string);
    abstract set signatureVersion(signatureVersion: string);
    abstract set forcePathStyle(forcePathStyle: boolean);
    abstract setConfig(): void;
}
export declare class S3StorageConnect extends StorageConnect {
    private static _instance;
    private _storage;
    private _bucketName;
    private _regionName;
    private _accessKeyId;
    private _secretAccessKey;
    private _protocol;
    private _hostname;
    private _apiVersion;
    private _signatureVersion;
    private _forcePathStyle;
    private _baseFilePath;
    private constructor();
    static getInstance(): S3StorageConnect;
    get storage(): S3;
    get baseFilePath(): string;
    set bucketName(bucketName: string);
    set regionName(regionName: string);
    set accessKeyId(accessKeyId: string);
    set secretAccessKey(secretAccessKey: string);
    set protocol(protocol: string);
    set hostname(hostname: string);
    set apiVersion(apiVersion: string);
    set signatureVersion(signatureVersion: string);
    set forcePathStyle(forcePathStyle: boolean);
    setConfig(): void;
}
